define("qtype_proforma/inlinemessages",["exports"],(function(_exports){
/**
   * Display error messages inline in Codemirror editor.
   *
   * @package    qtype_proforma
   * @copyright  2021 Ostfalia Hochschule fuer angewandte Wissenschaften
   * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   * @author     K.Borm <k.borm[at]ostfalia.de>
   */
function _hideWidgets(widgets){for(let i=0;i<widgets.length;++i)widgets[i].clear();return widgets.length=0,widgets}Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.embedError=void 0;function _embedErrorWithDocumentLoaded(cmid,collapsregion,regexp,filename){var id,widgets=[];cmid=CSS.escape(cmid),(id=collapsregion,new Promise((resolve=>{const wait=()=>{const element=document.getElementById(id);element&&resolve(element),window.requestAnimationFrame(wait)};wait()}))).then((region=>{return node=region,selector="a",new Promise((resolve=>{const wait=()=>{const element=node.querySelector(selector);element&&resolve(element),window.requestAnimationFrame(wait)};wait()}));var node,selector})).then((a_element=>{let messages=function(collapsregion,regexp,editorfilename){let messages=[],testlogs=document.getElementById(collapsregion).querySelectorAll(".proforma_testlog"),innertext="",re=new RegExp(regexp,"mg");for(let testlog of testlogs){let log;log=0===testlog.innerText.length?testlog.textContent:testlog.innerText,log.match(re)&&(innertext=innertext.length>0?innertext+"\n"+log:log)}let results=innertext.matchAll(re);for(let result of results){let{msgtype:msgtype,filename:filename,line:line,text:text,symbol:symbol}=result.groups;if(void 0!==filename&&null!=editorfilename&&0!==editorfilename.localeCompare(filename))continue;let error={line:line,text:text,msgtype:msgtype};void 0!==symbol&&(error.text=error.text+" '"+symbol.trim()+"'"),messages.push(error)}return messages}(collapsregion,regexp,filename);if(0==messages.length)return;const values=function(messages){let errors=0,warnings=0,infos=0,somethingelse=0;if(messages)for(let i=0;i<messages.length;++i){let msg=messages[i];if(msg)if(void 0!==msg.msgtype)switch(msg.msgtype.toLowerCase()){case"error":errors++;break;case"warn":case"warning":warnings++;break;case"info":infos++;break;default:console.error("do not know message type "+msg.msgtype),somethingelse++}else errors++}return[errors,warnings,infos,somethingelse]}(messages),errors=values[0],warnings=values[1],infos=values[2],somethingelse=values[3];let label=" ";errors>0&&(label+=errors+'<span class="proforma-dot-icon proforma-error-icon">x</span> '),warnings>0&&(label+=warnings+'<span class="proforma-warn-icon proforma-warning"/></span> '),infos>0&&(label+=infos+'<span class="proforma-dot-icon proforma-info-icon">i</span> '),somethingelse>0&&(label+=somethingelse+'<span class="proforma-dot-icon proforma-else-icon">?</span> ');let button=document.createElement("button");button.type="button",button.className="proforma-feedback-msg-btn",button.innerHTML=label,a_element.insertAdjacentElement("afterend",button);let showMsg=!1;button.addEventListener("click",(function(){let editor=function(target){let _target=target;if("string"==typeof _target&&(_target=document.querySelector(_target)),null===_target||void 0===!_target.tagName)throw new Error("Element "+target+" does not reference a CodeMirror instance.");return"TEXTAREA"===_target.tagName?_target.nextSibling.CodeMirror:(console.error("could not find Codemirror editor for "+target),null)}("#"+cmid);showMsg?(widgets=_hideWidgets(widgets),button.className="proforma-feedback-msg-btn",showMsg=!1):(widgets=function(editor,errors,widgets){widgets=_hideWidgets(widgets);for(let i=0;i<errors.length;++i){let err=errors[i];if(err){var icon,msg=document.createElement("div");if(void 0!==err.msgtype)switch(err.msgtype.toLowerCase()){case"error":(icon=msg.appendChild(document.createElement("span"))).innerHTML="x",icon.className="proforma-dot-icon proforma-error-icon",msg.className="proforma-inline-error";break;case"warn":case"warning":(icon=msg.appendChild(document.createElement("span"))).className="proforma-warn-icon proforma-warning",msg.className="proforma-inline-warning";break;case"info":(icon=msg.appendChild(document.createElement("span"))).innerHTML="i",icon.className="proforma-dot-icon proforma-info-icon",msg.className="proforma-inline-info";break;default:(icon=msg.appendChild(document.createElement("span"))).innerHTML="?",icon.className="proforma-dot-icon proforma-else-icon",msg.className="proforma-inline-info",console.error("do not know message type "+err.msgtype)}else(icon=msg.appendChild(document.createElement("span"))).innerHTML="x",icon.className="proforma-dot-icon proforma-error-icon",msg.className="proforma-inline-error";msg.appendChild(document.createTextNode(" "+err.text));var widget=editor.addLineWidget(err.line-1,msg,{coverGutter:!0,noHScroll:!0});widgets.push(widget)}}let info=editor.getScrollInfo(),after=editor.charCoords({line:editor.getCursor().line+1,ch:0},"local").top;return info.top+info.clientHeight<after&&editor.scrollTo(null,after-info.clientHeight+3),widgets}(editor,messages,widgets),button.className="proforma-feedback-msg-btn active",showMsg=!0)}))})).catch((error=>{console.error(error)}))}_exports.embedError=(cmid,collapsregion,regexp,filename)=>{cmid?"loading"!==document.readyState?_embedErrorWithDocumentLoaded(cmid,collapsregion,regexp,filename):document.addEventListener("DOMContentLoaded",(function(){_embedErrorWithDocumentLoaded(cmid,collapsregion,regexp,filename)})):console.error("cmid is invalid")}}));

//# sourceMappingURL=inlinemessages.min.js.map